'-------------------------------------------------------------------------------
'       DDS AD9913 SG 25MHz CLK x10  by  S.Yoshikawa JE2TLZ 20210121
'        Sample Code  Bascom AVR
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"
$hwstack = 40
$swstack = 32
$framesize = 32
$crystal = 12000000                                         '12MHz

Config Portd = &B00111100                                   '2=SCLK, 3=SDIO, 4=IO-UP,5=RESET <out>

Dim Sng_wrk As Single                                       'Single work
Dim Sgfreq As Long
Dim Data32_1 As Long
Dim Wrd_cmd As Word
Dim Byt_cmd As Byte                                         'DDS commandi
'
Const Scal = 171.798692                                     'AD9913 250MHz  Freq disp*10
'
Set Portd.5                                                 'master reset AD9913
Wait 1
Reset Portd.5                                               'reset low AD9913
'
Sgfreq = 2800000                                            'Freq 28MHz
'
Gosub Ad99_cfr2                                             'AD9913 CFR2 set
Wait 1
'
Gosub Ad99_ftw                                              'DDS CW mode freq set
'
Do
   Wait 1
Loop

'-----------------------------
'  Subroutine
'-----------------------------
'-----------------------------
'  AD9913 CW Freq send
'-----------------------------
Ad99_ftw:
   Byt_cmd = &H03                                           'FTW
   Sng_wrk = Sgfreq * Scal                                  'Freq data keisan
   Data32_1 = Sng_wrk                                       '32bit henkan
   Gosub Dds32send
Return

'-----------------------------
'  AD9913 init send
'-----------------------------
Ad99_cfr2:
   Byt_cmd = &H01                                           'CFR2
   Wrd_cmd = &H1450                                         'Xtal PLL x10 reset
'   Wrd_cmd = &H1850                                         'Xtal PLL x12 reset
   Gosub Dds16send
   Waitms 100
   Wrd_cmd = &H1452                                         'Xtal PLL x10
'   Wrd_cmd = &H1852                                         'Xtal PLL x12
   Gosub Dds16send
   Waitms 100
Return

'-----------------------------
'  AD9913 cmd data send (16bit)
'-----------------------------
Dds16send:
   Reset Portd.4                                            'IO_up L
   Waitus 10
   Shiftout Portd.3 , Portd.2 , Byt_cmd , 1 , 8             'Addres
   Shiftout Portd.3 , Portd.2 , Wrd_cmd , 1 , 16            'DDS data clk
   Waitus 5
   Set Portd.4                                              'IO_up H
   Waitus 10
Return

'-----------------------------
'  AD9913 cmd data send (32bit)
'-----------------------------
Dds32send:
   Reset Portd.4                                            'IO_up L
   Waitus 10
   Shiftout Portd.3 , Portd.2 , Byt_cmd , 1 , 8             'Addres
   Shiftout Portd.3 , Portd.2 , Data32_1 , 1 , 32           'DDS data clk
   Waitus 10
   Set Portd.4                                              'IO_up H
   Waitus 10
Return

End